openapi: 3.0.1
info:
  title: OpenAPI definition
  version: v0
servers:
- description: Generated server url
  url: http://localhost:8081
tags:
- description: API for managing credentials
  name: Credential API
- description: API for managing users
  name: User API
- description: API for perform agent operations
  name: Agent API
- description: API for managing roles
  name: Role API
paths:
  /user/{uuid}:
    delete:
      description: Deletes a user by its UUID
      operationId: deleteUser
      parameters:
      - description: The UUID of the user
        example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
        explode: false
        in: path
        name: uuid
        required: true
        schema:
          type: string
        style: simple
      responses:
        "204":
          description: User deleted successfully
        "400":
          description: Invalid UUID format
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: User not found
      summary: Delete user
      tags:
      - User API
    get:
      description: Retrieves a user by its UUID
      operationId: getUserByUuid
      parameters:
      - description: The UUID of the user
        example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
        explode: false
        in: path
        name: uuid
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/KeycloakUserDTO'
          description: Successfully retrieved user
        "400":
          description: Invalid UUID format
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: User not found
      summary: Get user by UUID
      tags:
      - User API
    put:
      description: Updates the details of an existing user by its UUID
      operationId: updateUser
      parameters:
      - description: The UUID of the user
        example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
        explode: false
        in: path
        name: uuid
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/KeycloakUserDTO'
        description: The user details to update
        required: true
      responses:
        "200":
          description: User updated successfully
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: User not found
      summary: Update user
      tags:
      - User API
  /user/{uuid}/roles:
    get:
      description: Retrieves the roles associated with a user by its UUID
      operationId: getRoles
      parameters:
      - description: The UUID of the user
        example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
        explode: false
        in: path
        name: uuid
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/KeycloakRoleDTO'
                type: array
          description: Successfully retrieved user roles
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: User not found
      summary: Get user roles
      tags:
      - User API
    put:
      description: Updates the roles associated with a user by its UUID
      operationId: updateUserRoles
      parameters:
      - description: The UUID of the user
        example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
        explode: false
        in: path
        name: uuid
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              items:
                type: string
              type: array
        description: The list of roles to be assigned to the user
        required: true
      responses:
        "200":
          description: User roles updated successfully
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: User not found
      summary: Update user roles
      tags:
      - User API
  /role:
    post:
      description: Creates a new role in the system with the provided details
      operationId: create
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/KeycloakRoleDTO'
        description: The details of the role to be created
        required: true
      responses:
        "201":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RoleDTO'
          description: Successfully created the role
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "409":
          description: "Conflict: role already exists"
      summary: Create a new role
      tags:
      - Role API
    put:
      description: Updates the details of an existing role in the system
      operationId: update
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/KeycloakRoleDTO'
        description: The details of the role to be updated
        required: true
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RoleDTO'
          description: Successfully updated the role
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: Cannot modify role's name or User does not have\
            \ the required role"
        "404":
          description: Role not found
        "409":
          description: Conflict
      summary: Update an existing role
      tags:
      - Role API
  /role/{id}/identity-attributes:
    put:
      description: Assigns a list of identity attribute IDs to a specified role
      operationId: replaceIdentityAttributes
      parameters:
      - description: The UUID of the role to which identity attributes will be assigned
        example: 123e4567-e89b-12d3-a456-426614174000
        explode: false
        in: path
        name: id
        required: true
        schema:
          format: uuid
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              items:
                type: string
              type: array
        description: List of identity attribute codes to be assigned to the role
        required: true
      responses:
        "200":
          description: Successfully assigned identity attributes
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: Role not found
      summary: Assign identity attributes to a role
      tags:
      - Role API
  /user:
    get:
      description: Retrieves a user by its email address
      operationId: getUser
      parameters:
      - description: The email of the user
        example: user@example.com
        explode: true
        in: query
        name: email
        required: true
        schema:
          type: string
        style: form
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/KeycloakUserDTO'
          description: Successfully retrieved user
        "400":
          description: Invalid email format
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: User not found
      summary: Get user by email
      tags:
      - User API
    post:
      operationId: createUser
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/KeycloakUserDTO'
        required: true
      responses:
        "201":
          content:
            '*/*':
              schema:
                type: string
          description: Created
      tags:
      - User API
  /user/import:
    post:
      operationId: importUsers
      requestBody:
        content:
          application/json:
            schema:
              items:
                $ref: '#/components/schemas/KeycloakUserDTO'
              type: array
        required: true
      responses:
        "201":
          description: Created
      tags:
      - User API
  /user/as-t1user:
    post:
      description: Creates a new tier-one user
      operationId: createUserAsT1
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/KeycloakUserDTO'
        description: The user details
        required: true
      responses:
        "201":
          content:
            text/plain:
              schema:
                description: The Id of the newly created user
                example: 01929051-2adb-7ee5-994a-b36f64fbb4dd
                type: string
          description: User created successfully
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "409":
          description: "Conflict: User already exists"
      summary: Create a user
      tags:
      - User API
  /session/credential:
    post:
      description: Validate the tier one session against the ephemeral proof stored
        in the agent
      operationId: validateTierOneSession
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TierOneSessionDTO'
        required: true
      responses:
        "204":
          description: Tier 1 session validated successfully
        "422":
          description: Invalid Tier 1 session
      summary: Validate Tier 1 session
      tags:
      - session-controller
  /role/{id}/duplicate-identity-attribute:
    post:
      description: Duplicates identity attributes from the source role to the destination
        role
      operationId: duplicateIdentityAttributeToAnOtherRole
      parameters:
      - description: The UUID of the source role
        explode: false
        in: path
        name: id
        required: true
        schema:
          format: uuid
          type: string
        style: simple
      requestBody:
        content:
          application/json:
            schema:
              format: uuid
              type: string
        description: The UUID of the destination role
        required: true
      responses:
        "200":
          description: Successfully duplicated identity attributes
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: Source or destination role not found
      summary: Duplicate identity attributes to another role
      tags:
      - Role API
  /role/import:
    post:
      operationId: importRoles
      requestBody:
        content:
          application/json:
            schema:
              items:
                $ref: '#/components/schemas/KeycloakRoleDTO'
              type: array
        required: true
      responses:
        "201":
          description: Created
      tags:
      - Role API
  /role/assigned-identity-attributes:
    post:
      description: Retrieves a list of identity attributes associated with the provided
        roles
      operationId: getIdentityAttributesFromRoleList
      requestBody:
        content:
          application/json:
            schema:
              items:
                type: string
              type: array
        description: List of role names from which to retrieve identity attributes
        required: true
      responses:
        "200":
          content:
            '*/*':
              schema:
                items:
                  type: string
                type: array
          description: Successfully retrieved identity attributes
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      summary: Get identity attributes from role list
      tags:
      - Role API
  /mtls/ephemeral-proof:
    post:
      description: Stores the ephemeral proof for a participant identified by their
        UUID
      operationId: storeCallerEphemeralProof
      parameters:
      - description: The Public Key Hash of the participant
        explode: false
        in: header
        name: Credential-Id
        required: true
        schema:
          type: string
        style: simple
      requestBody:
        content:
          text/plain:
            schema:
              type: string
        description: The ephemeral proof to be stored
        required: true
      responses:
        "200":
          description: Ephemeral proof successfully stored
        "400":
          description: Invalid input data
        "404":
          description: Participant not found
      summary: Store Ephemeral Proof
      tags:
      - mtls-controller
  /credential:
    delete:
      description: Deletes the existing credential from the server
      operationId: delete
      responses:
        "204":
          description: Successfully deleted credential
        "404":
          description: Credential not found
      summary: Delete the credential
      tags:
      - Credential API
    get:
      description: "Returns true if a credential is present, false otherwise"
      operationId: hasCredential
      responses:
        "200":
          content:
            application/json:
              schema:
                description: Boolean indicating if a credential is present
                example: true
                type: boolean
          description: Successfully checked credential presence
      summary: Check if a credential is present
      tags:
      - Credential API
    post:
      description: Uploads a credential file to the server and returns the ID of the
        uploaded credential
      operationId: uploadCredential
      requestBody:
        content:
          multipart/form-data:
            schema:
              $ref: '#/components/schemas/uploadCredential_request'
      responses:
        "201":
          content:
            application/json:
              schema:
                description: The id of the uploaded credential
                example: 12345
                type: integer
          description: Successfully uploaded credential
        "400":
          description: Invalid file format
      summary: Upload a credential file
      tags:
      - Credential API
  /user/search:
    get:
      description: Searches for users based on various filter criteria
      operationId: search
      parameters:
      - explode: true
        in: query
        name: username
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: firstName
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: lastName
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: email
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: first
        required: false
        schema:
          format: int32
          type: integer
        style: form
      - explode: true
        in: query
        name: max
        required: false
        schema:
          format: int32
          type: integer
        style: form
      responses:
        "200":
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/KeycloakUserDTO'
                type: array
          description: Successfully retrieved list of users
        "400":
          description: Invalid filter criteria
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      summary: Search users
      tags:
      - User API
  /session/{credentialId}:
    get:
      description: Fetches the identity attributes associated with the specified participant
        ID
      operationId: getIdentityAttributesOfParticipant
      parameters:
      - description: The Public Key Hash of the participant
        explode: false
        in: path
        name: credentialId
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/IdentityAttributeDTO'
                type: array
          description: Successfully retrieved identity attributes
        "404":
          description: Ephemeral proof not found
      summary: Retrieve identity attributes of a participant
      tags:
      - session-controller
  /role/{id}:
    get:
      description: Retrieves a role by its unique identifier (UUID)
      operationId: findById
      parameters:
      - description: The UUID of the role
        example: 123e4567-e89b-12d3-a456-426614174000
        explode: false
        in: path
        name: id
        required: true
        schema:
          format: uuid
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RoleDTO'
          description: Successfully retrieved the role
        "400":
          description: Invalid UUID format
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: Role not found
      summary: Find role by ID
      tags:
      - Role API
  /role/search:
    get:
      description: Searches for roles based on the provided filter criteria and pagination
        settings
      operationId: search_1
      parameters:
      - explode: true
        in: query
        name: name
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: description
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: attributeName
        required: false
        schema:
          type: string
        style: form
      - description: Zero-based page index (0..N)
        explode: true
        in: query
        name: page
        required: false
        schema:
          default: 0
          minimum: 0
          type: integer
        style: form
      - description: The size of the page to be returned
        explode: true
        in: query
        name: size
        required: false
        schema:
          default: 10
          minimum: 1
          type: integer
        style: form
      - description: "Sorting criteria in the format: property,(asc|desc). Default\
          \ sort order is ascending. Multiple sort criteria are supported."
        explode: true
        in: query
        name: sort
        required: false
        schema:
          default:
          - "id,ASC"
          items:
            type: string
          type: array
        style: form
      responses:
        "200":
          content:
            '*/*':
              schema:
                $ref: '#/components/schemas/PageResponseRoleDTO'
          description: Successfully retrieved the list of roles
        "400":
          description: Invalid filter or pagination parameters
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      summary: Search roles
      tags:
      - Role API
  /mtls/ping:
    get:
      description: Performs a ping operation to check the participant's status using
        its credential id
      operationId: ping
      parameters:
      - description: The Public Key Hash of the participant
        explode: false
        in: header
        name: Credential-Id
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ParticipantWithIdentityAttributesDTO'
          description: Successfully pinged the participant
        "404":
          description: Participant not found
      summary: Ping the participant
      tags:
      - mtls-controller
  /identity-attribute/search:
    get:
      description: Searches for identity attributes with ownership based on the provided
        filter and pagination settings
      operationId: search_2
      parameters:
      - explode: true
        in: query
        name: code
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: name
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: enabled
        required: false
        schema:
          type: boolean
        style: form
      - explode: true
        in: query
        name: participantTypeIn
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: participantTypeNotIn
        required: false
        schema:
          type: string
        style: form
      - explode: true
        in: query
        name: assignedToParticipant
        required: false
        schema:
          type: boolean
        style: form
      - explode: true
        in: query
        name: updateTimestampFrom
        required: false
        schema:
          format: date-time
          type: string
        style: form
      - explode: true
        in: query
        name: updateTimestampTo
        required: false
        schema:
          format: date-time
          type: string
        style: form
      - description: Zero-based page index (0..N)
        explode: true
        in: query
        name: page
        required: false
        schema:
          default: 0
          minimum: 0
          type: integer
        style: form
      - description: The size of the page to be returned
        explode: true
        in: query
        name: size
        required: false
        schema:
          default: 10
          minimum: 1
          type: integer
        style: form
      - description: "Sorting criteria in the format: property,(asc|desc). Default\
          \ sort order is ascending. Multiple sort criteria are supported."
        explode: true
        in: query
        name: sort
        required: false
        schema:
          default:
          - "id,ASC"
          items:
            type: string
          type: array
        style: form
      responses:
        "200":
          content:
            '*/*':
              schema:
                $ref: '#/components/schemas/PagedModelIdentityAttributeWithOwnershipDTO'
          description: Successfully retrieved the identity attributes
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      summary: Search identity attributes with ownership
      tags:
      - identity-attribute-controller
  /credential/public-key:
    get:
      description: Fetches the public key associated with the stored credential
      operationId: getPublicKey
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CredentialDTO'
          description: Successfully retrieved public key
        "404":
          description: Credential not found
      summary: Retrieve the public key
      tags:
      - Credential API
  /credential/my-id:
    get:
      description: Fetches the participant ID associated with the current participant
      operationId: getMyParticipantId
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ParticipantDTO'
          description: Successfully retrieved participant ID
        "404":
          description: Credential not found
      summary: Retrieve participant ID
      tags:
      - Credential API
  /credential/download:
    get:
      operationId: downloadInstalledCredentials
      responses:
        "200":
          content:
            '*/*':
              schema:
                $ref: '#/components/schemas/StreamingResponseBody'
          description: OK
      tags:
      - Credential API
  /credential/credential-id:
    get:
      description: Fetches the credential ID associated with the current participant
      operationId: getCredentialId
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ParticipantDTO'
          description: Successfully retrieved credential ID
        "404":
          description: Credential not found
      summary: Retrieve credential ID
      tags:
      - Credential API
  /agent/ping:
    get:
      description: Pings a participant using the provided FQDN and returns identity
        attributes
      operationId: ping_1
      parameters:
      - description: Fully Qualified Domain Name of the participant
        explode: true
        in: query
        name: fqdn
        required: true
        schema:
          type: string
        style: form
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ParticipantWithIdentityAttributesDTO'
          description: Successfully pinged the participant
        "400":
          description: Invalid FQDN provided
      summary: Ping a participant
      tags:
      - Agent API
  /agent/identity-attributes:
    get:
      description: Returns a list of identity attributes with ownership details
      operationId: getIdentityAttributesWithOwnership
      responses:
        "200":
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/IdentityAttributeWithOwnershipDTO'
                type: array
          description: Successfully retrieved identity attributes with ownership
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      summary: Get identity attributes with ownership
      tags:
      - Agent API
  /agent/identity-attributes/{credentialId}:
    get:
      description: Returns a list of identity attributes with ownership details
      operationId: getParticipantIdentityAttributes
      parameters:
      - description: The certificate ID of the participant
        explode: true
        in: query
        name: certificateId
        required: true
        schema:
          type: string
        style: form
      - explode: false
        in: path
        name: credentialId
        required: true
        schema:
          type: string
        style: simple
      responses:
        "200":
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/IdentityAttributeDTO'
                type: array
          description: Successfully retrieved identity attributes with ownership
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      summary: Get identity attributes with ownership
      tags:
      - Agent API
  /agent/echo:
    get:
      description: Returns echo information including connection and MTLS status
      operationId: echo
      responses:
        "200":
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EchoDTO'
          description: Successfully retrieved echo information
      summary: Get echo information
      tags:
      - Agent API
  /session/current:
    delete:
      description: End the session for the current user
      operationId: deleteCurrentSession
      responses:
        "204":
          description: Successfully deleted user session
        "400":
          description: Communication error with Keycloak admin
      summary: Current User Logout
      tags:
      - session-controller
  /role/{roleId}:
    delete:
      description: Removes a role from the system using its id
      operationId: delete_1
      parameters:
      - description: The name of the role to be deleted
        explode: false
        in: path
        name: roleId
        required: true
        schema:
          format: uuid
          type: string
        style: simple
      responses:
        "204":
          description: Successfully deleted the role
        "400":
          description: Invalid role name
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
        "404":
          description: Role not found
      summary: Delete a role by id
      tags:
      - Role API
  /role/delete-attribute:
    delete:
      description: Removes an identity attribute from a specified role
      operationId: deleteAttributeFromRole
      parameters:
      - description: The UUID of the role from which the attribute will be removed
        explode: true
        in: query
        name: roleId
        required: true
        schema:
          format: uuid
          type: string
        style: form
      - description: The code of the attribute to be removed
        explode: true
        in: query
        name: attributeCode
        required: true
        schema:
          type: string
        style: form
      responses:
        "204":
          description: Successfully removed the attribute from the role
        "400":
          description: Invalid input data
        "401":
          description: Access denied
        "403":
          description: "Forbidden: User does not have the required role"
      summary: Delete an identity attribute from a role
      tags:
      - Role API
components:
  schemas:
    ErrorDTO:
      properties:
        error:
          type: string
        elementName:
          type: string
      type: object
    KeycloakUserDTO:
      example:
        firstName: firstName
        lastName: lastName
        password: password
        roles:
        - roles
        - roles
        id: id
        email: email
        username: username
      properties:
        id:
          readOnly: true
          type: string
        username:
          type: string
        firstName:
          type: string
        lastName:
          type: string
        email:
          type: string
        password:
          type: string
        roles:
          items:
            type: string
          type: array
      required:
      - email
      - firstName
      - lastName
      - password
      - username
      type: object
    KeycloakRoleDTO:
      example:
        name: name
        description: description
      properties:
        name:
          type: string
        description:
          type: string
      required:
      - name
      type: object
    RoleDTO:
      example:
        assignedIdentityAttributes:
        - assignedIdentityAttributes
        - assignedIdentityAttributes
        name: name
        description: description
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
      properties:
        id:
          format: uuid
          type: string
        name:
          type: string
        description:
          type: string
        assignedIdentityAttributes:
          items:
            type: string
          type: array
      required:
      - id
      - name
      type: object
    TierOneSessionDTO:
      example:
        jwt: jwt
      properties:
        jwt:
          type: string
      required:
      - jwt
      type: object
    IdentityAttributeDTO:
      example:
        code: code
        name: name
        creationTimestamp: 2000-01-23T04:56:07.000+00:00
        description: description
        assignableToRoles: true
        participantTypes:
        - participantTypes
        - participantTypes
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        used: true
        enabled: true
        updateTimestamp: 2000-01-23T04:56:07.000+00:00
      properties:
        id:
          format: uuid
          type: string
        code:
          type: string
        name:
          type: string
        description:
          type: string
        assignableToRoles:
          type: boolean
        enabled:
          type: boolean
        creationTimestamp:
          format: date-time
          type: string
        updateTimestamp:
          format: date-time
          type: string
        participantTypes:
          items:
            type: string
          type: array
          uniqueItems: true
        used:
          readOnly: true
          type: boolean
      required:
      - assignableToRoles
      - code
      - enabled
      - name
      type: object
    PageMetadata:
      example:
        number: 6
        size: 0
        totalPages: 5
        totalElements: 1
      properties:
        size:
          format: int64
          type: integer
        number:
          format: int64
          type: integer
        totalElements:
          format: int64
          type: integer
        totalPages:
          format: int64
          type: integer
      type: object
    PageResponseRoleDTO:
      example:
        page:
          number: 6
          size: 0
          totalPages: 5
          totalElements: 1
        content:
        - assignedIdentityAttributes:
          - assignedIdentityAttributes
          - assignedIdentityAttributes
          name: name
          description: description
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        - assignedIdentityAttributes:
          - assignedIdentityAttributes
          - assignedIdentityAttributes
          name: name
          description: description
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        empty: true
      properties:
        content:
          items:
            $ref: '#/components/schemas/RoleDTO'
          type: array
        page:
          $ref: '#/components/schemas/PageMetadata'
        empty:
          type: boolean
      type: object
    ParticipantDTO:
      example:
        expiryDate: 2000-01-23T04:56:07.000+00:00
        organization: organization
        participantType: participantType
        creationTimestamp: 2000-01-23T04:56:07.000+00:00
        credentialId: credentialId
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        updateTimestamp: 2000-01-23T04:56:07.000+00:00
      properties:
        id:
          format: uuid
          type: string
        participantType:
          type: string
        organization:
          type: string
        creationTimestamp:
          format: date-time
          type: string
        updateTimestamp:
          format: date-time
          type: string
        credentialId:
          type: string
        expiryDate:
          format: date-time
          type: string
      required:
      - organization
      - participantType
      type: object
    ParticipantWithIdentityAttributesDTO:
      example:
        expiryDate: 2000-01-23T04:56:07.000+00:00
        organization: organization
        participantType: participantType
        creationTimestamp: 2000-01-23T04:56:07.000+00:00
        credentialId: credentialId
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        identityAttributes:
        - code: code
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
        - code: code
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
        updateTimestamp: 2000-01-23T04:56:07.000+00:00
      properties:
        id:
          format: uuid
          type: string
        participantType:
          type: string
        organization:
          type: string
        creationTimestamp:
          format: date-time
          type: string
        updateTimestamp:
          format: date-time
          type: string
        credentialId:
          type: string
        expiryDate:
          format: date-time
          type: string
        identityAttributes:
          items:
            $ref: '#/components/schemas/IdentityAttributeDTO'
          type: array
      required:
      - organization
      - participantType
      type: object
    IdentityAttributeWithOwnershipDTO:
      example:
        code: code
        assignedToParticipant: true
        name: name
        creationTimestamp: 2000-01-23T04:56:07.000+00:00
        description: description
        assignableToRoles: true
        participantTypes:
        - participantTypes
        - participantTypes
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        used: true
        enabled: true
        updateTimestamp: 2000-01-23T04:56:07.000+00:00
      properties:
        id:
          format: uuid
          type: string
        code:
          type: string
        name:
          type: string
        description:
          type: string
        assignableToRoles:
          type: boolean
        enabled:
          type: boolean
        creationTimestamp:
          format: date-time
          type: string
        updateTimestamp:
          format: date-time
          type: string
        participantTypes:
          items:
            type: string
          type: array
          uniqueItems: true
        used:
          readOnly: true
          type: boolean
        assignedToParticipant:
          type: boolean
      required:
      - assignableToRoles
      - code
      - enabled
      - name
      type: object
    PagedModelIdentityAttributeWithOwnershipDTO:
      example:
        page:
          number: 6
          size: 0
          totalPages: 5
          totalElements: 1
        content:
        - code: code
          assignedToParticipant: true
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
        - code: code
          assignedToParticipant: true
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
      properties:
        content:
          items:
            $ref: '#/components/schemas/IdentityAttributeWithOwnershipDTO'
          type: array
        page:
          $ref: '#/components/schemas/PageMetadata'
      type: object
    CredentialDTO:
      example:
        publicKey: publicKey
      properties:
        publicKey:
          type: string
      type: object
    StreamingResponseBody:
      type: object
    ConnectionStatus:
      enum:
      - CONNECTED
      - NOT_CONNECTED
      type: string
    EchoDTO:
      example:
        mtlsStatus: SECURED
        participantType: participantType
        userIdentityAttributes:
        - userIdentityAttributes
        - userIdentityAttributes
        identityAttributes:
        - code: code
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
        - code: code
          name: name
          creationTimestamp: 2000-01-23T04:56:07.000+00:00
          description: description
          assignableToRoles: true
          participantTypes:
          - participantTypes
          - participantTypes
          id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
          used: true
          enabled: true
          updateTimestamp: 2000-01-23T04:56:07.000+00:00
        updateTimestamp: 2000-01-23T04:56:07.000+00:00
        expiryDate: 2000-01-23T04:56:07.000+00:00
        organization: organization
        connectionStatus: CONNECTED
        creationTimestamp: 2000-01-23T04:56:07.000+00:00
        credentialId: credentialId
        id: 046b6c7f-0b8a-43b9-b35d-6489e6daee91
        email: email
        username: username
      properties:
        username:
          type: string
        email:
          type: string
        connectionStatus:
          $ref: '#/components/schemas/ConnectionStatus'
        mtlsStatus:
          $ref: '#/components/schemas/MTLSStatus'
        userIdentityAttributes:
          items:
            type: string
          type: array
        id:
          format: uuid
          type: string
        participantType:
          type: string
        organization:
          type: string
        creationTimestamp:
          format: date-time
          type: string
        updateTimestamp:
          format: date-time
          type: string
        credentialId:
          type: string
        expiryDate:
          format: date-time
          type: string
        identityAttributes:
          items:
            $ref: '#/components/schemas/IdentityAttributeDTO'
          type: array
      required:
      - organization
      - participantType
      type: object
    MTLSStatus:
      enum:
      - SECURED
      - NOT_SECURED
      type: string
    uploadCredential_request:
      properties:
        file:
          format: binary
          type: string
      required:
      - file
      type: object
